//----------------------------------------------------------------------------------
// aviutl  GPUJX^tB^
// Copyright (c) 2007-2009  N099
//----------------------------------------------------------------------------------
#pragma once

#include <vector>
#include <hash_map>

#include "dxh_mng.h"

//MT
typedef BOOL (__cdecl * EXEC_MT)(MULTI_THREAD_FUNC, void*, void*);
class CpCvt;

//GPUtB^NX
class GpuFilter
{
private:
	IDirect3D9 *m_pD3D; //IDirect3D9IuWFNg
	IDirect3DDevice9 *m_pd3dDevice; //D3DfoCX

	IDirect3DTexture9 *m_pTexSys; //Rs[ɗpeNX`
	
	IDirect3DVertexBuffer9 *m_pVert; //`p_
	IDirect3DVertexDeclaration9 *m_pVertDec; //`p_錾

	ID3DXEffect  *m_pEffect; //GtFNg
	EffectReader &m_pEffectReader;

	//QƉ摜eNX`
	std::vector<IDirect3DTexture9*> m_pTexSrc;
	stdext::hash_map<int, IDirect3DTexture9*> m_mTexSrc;
	stdext::hash_map<int, IDirect3DTexture9*> m_mTexSrcUpd; //XVKvȂ
	bool m_TxCur; //t[ItZbg0̎QƃeNX`݂邩H

	//_[^[Qbg̃eNX`
	std::vector<IDirect3DTexture9*> m_pTexRT;

	//p[^
	std::vector<TrackHandle> m_hTrack;
	std::vector<CheckHandle> m_hCheck;
	std::vector<TechHandle> m_hTech;
	int m_tech; //gpeNjbNԍ

	//\[X摜nh
	std::vector<TxSrcHandle> m_hTxSrc;

	//Qƃt[ItZbginhItZbgȂ̂Łj
	std::vector<int> m_nRefOffs;

	//_[^[Qbg
	std::vector<D3DXHANDLE> m_hTxRT;

	//J[lW
	std::vector<KernelHandle> m_hKern;

	//̃p[^
	D3DXHANDLE m_hTxTmp;    //e|摜
	D3DXHANDLE m_hFrame;    //݂̃t[
	D3DXHANDLE m_hFrameNum; //St[
	D3DXHANDLE m_hSrcSize;  //摜TCY
	D3DXHANDLE m_hPixScale; //sNZ̃XP[O

	//摜TCY
	int m_width;
	int m_height;
	int m_wMax;

	int m_frame;
	int m_frame_num;
	int m_frame_set[2]; //ǂݗ\

	//񏈗p
	ThrProc m_tproc;

	//tH[}bg
	enum PIXEL_FORMAT { F32 = 0, F16, U16, B16, S16, U10, Unknown };
	enum PARAM_USAGE  { DEF = 0, NORM, NORM2, TECH, EVEN, ODD, ODD0, NONE };

	PIXEL_FORMAT m_pixFormat; //gpsNZtH[}bg
	bool m_pixFormatAvailable[Unknown];

	//f[^̃Rs[p
	CpCvt *m_pCpCvt;

	//device caps
	D3DCAPS9 m_caps;

public:
	GpuFilter(EffectReader &er);
	~GpuFilter();

	bool Init(FILTER *fp, int dev, bool pp);
	bool AllocResources(int w, int h, int w_max);
	bool TestDeviceState(bool *realloc);
	bool ReleaseResources();
	bool SetParams(int *track, int *check);
	bool SetFrame(int cur, int num);
	bool PutImage(const PIXEL_YC *data, int n, EXEC_MT func_mt);
	bool GetImage(PIXEL_YC *data, EXEC_MT func_mt);
	bool ProcImage(int *next);
	bool ClearRefFrames();

	int GetWidth() const { return m_width; }
	int GetHeight() const { return m_height; }
	
	int GetRefFrameCount() const { return (int)m_nRefOffs.size(); }
	int GetRefFrame(int idx) const { return m_nRefOffs[idx] + m_frame; }
	bool IsFrameCached(int frame) const
	{ return m_mTexSrc.find(frame) != m_mTexSrc.end(); };

private:

	HRESULT CheckDeviceCap();
	HRESULT CreateEffect();
	HRESULT ParseEffect();
	HRESULT TestEffect();
	HRESULT CreateVert();
	HRESULT CreateTexture(IDirect3DTexture9 **ppTex, DWORD usage, D3DPOOL pool);
	HRESULT CreateSurface(IDirect3DSurface9 **ppSrf, DWORD usage, D3DPOOL pool);
	HRESULT CreateSysMemResources();
	HRESULT CreateDefaultResources();
	HRESULT SetEffectResources();
	HRESULT ReleaseSysMemResources();
	HRESULT ReleaseDefaultResources();
	HRESULT Reset();
	HRESULT ProcImage();
	HRESULT PutPixelData(IDirect3DTexture9 *dst, const PIXEL_YC *src, EXEC_MT func_mt);
	HRESULT PutPixelData(IDirect3DTexture9 *dst, IDirect3DTexture9 *sys);
	HRESULT CopyPixelData(IDirect3DTexture9 *sys, const PIXEL_YC *src, EXEC_MT func_mt);
	HRESULT SetRenderTarget(IDirect3DTexture9 *rtt);
	HRESULT SetRenderTarget(const RtTbl &rt);
	HRESULT GetRenderTargetData();
	HRESULT CopyPixelData(PIXEL_YC *dst, IDirect3DTexture9 *sys, EXEC_MT func_mt);
	HRESULT ShowMessageBox(const char *file, DWORD line, HRESULT hr, const TCHAR *msg);

	HRESULT ProcTrack(const TrackHandle *h, int track);
	HRESULT ProcCheck(const CheckHandle *h, int check);

	HRESULT CheckRtTexFormat(UINT ad, D3DDEVTYPE dt, D3DFORMAT af, D3DFORMAT tgt) const;
	PIXEL_FORMAT GetPixelFormat() const { return m_pixFormat; }
	const TCHAR *GetPixelFormatStr() const;
	PIXEL_FORMAT PixelFormatFromIndex(int i) const
	{ return (PIXEL_FORMAT)((i<0) ? 0 : ((i>Unknown) ? Unknown : i)); }
	D3DFORMAT PicFmtToD3DFmt(PIXEL_FORMAT p) const;
	CpCvt::CpCvtFmt PicFmtToCpCvtFmt(PIXEL_FORMAT p) const;
	const TCHAR *GetFilterName() const;

	static void __cdecl AsyncProc(void *param);

	GpuFilter& operator=(const GpuFilter &g);
	GpuFilter(const GpuFilter &g);
};

